class Soundgrab
  require 'json'
  require 'net/http'

  def self.grab_tracks(options = {})
    uri = URI("https://api.soundcloud.com/users/#{options[:user_id]}/tracks?client_id=#{options[:client_id]}&format=json")
    response = Net::HTTP.get_response(uri)
    if response.is_a?(Net::HTTPSuccess)
      tracks_json = JSON.parse(response.body)
      tracks = []
      tracks_json.each do |track|
        tracks << SoundcloudTrack.new(track)
      end
      tracks
    end
  end
end

class SoundcloudTrack
  attr_reader :id, :title, :image_url

  def initialize(params = {})
    @id = params["id"]
    @title = params["title"]
    @image_url = params["artwork_url"]
  end

  def embed_url
    "https://api.soundcloud.com/tracks/#{id}?auto_play=false&hide_related=false&show_comments=true&show_user=true&show_reposts=false&visual=true"
  end
end
